/*
 * Copyright@ Samsung Electronics Co. LTD
 *
 * This software is proprietary of Samsung Electronics.
 * No part of this software, either material or conceptual may be copied or distributed, transmitted,
 * transcribed, stored in a retrieval system or translated into any human or computer language in any form by any means,
 * electronic, mechanical, manual or otherwise, or disclosed
 * to third parties without the express written permission of Samsung Electronics.


 * Alternatively, this program is free software in case of open source projec;
 * you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.

*/

#ifndef __EXYNOS7570_H__
#define __EXYNOS7570_H__

/* EXYNOS7570 PLL */
#define CPUCL0_PLL_7570								0
#define SHARED0_PLL_7570								1
#define SHARED1_PLL_7570								2
#define SHARED2_PLL_7570								3
#define AUD_PLL_7570									4

/* SFR base address. */
#define EXYNOS7570_PRO_ID								0x10100000
#define EXYNOS7570_WATCHDOG_BASE 							0x10170000
#define EXYNOS7570_MCT_BASE								0x101B0000
#define EXYNOS7570_G_TCON								0x0240
#define EXYNOS7570_CMU_MIF_BASE 							0x10460000
#define EXYNOS7570_SHARED0_PLL_CON0 							(EXYNOS7570_CMU_MIF_BASE + 0x0100)
#define EXYNOS7570_SHARED1_PLL_CON0 							(EXYNOS7570_CMU_MIF_BASE + 0x0120)
#define EXYNOS7570_SHARED2_PLL_CON0 							(EXYNOS7570_CMU_MIF_BASE + 0x0140)
#define EXYNOS7570_CLK_CON_MUX_CLKCMU_FSYS_MMC0					(EXYNOS7570_CMU_MIF_BASE + 0x024C)
#define EXYNOS7570_CLK_CON_MUX_CLKCMU_FSYS_MMC2					(EXYNOS7570_CMU_MIF_BASE + 0x0250)
#define EXYNOS7570_CLK_CON_MUX_CLKCMU_PERI_UART_DEBUG					(EXYNOS7570_CMU_MIF_BASE + 0x0260)
#define EXYNOS7570_CLK_CON_DIV_CLKCMU_PERI_UART_DEBUG					(EXYNOS7570_CMU_MIF_BASE + 0x045C)
#define EXYNOS7570_CLK_CON_DIV_CLKCMU_FSYS_MMC0					(EXYNOS7570_CMU_MIF_BASE + 0x0448)
#define EXYNOS7570_CLK_CON_DIV_CLKCMU_FSYS_MMC2					(EXYNOS7570_CMU_MIF_BASE + 0x044C)
#define EXYNOS7570_CMU_CPUCL0_BASE 							0x10900000
#define EXYNOS7570_CPUCL0_PLL_CON0 							(EXYNOS7570_CMU_CPUCL0_BASE + 0x0100)
#define EXYNOS7570_POWER_BASE								0x11C80000
#define EXYNOS7570_SWRESET 								(EXYNOS7570_POWER_BASE + 0x400)
#define EXYNOS7570_POWER_DFD_RESET_SEQUENCER_CONFIGURATION				(EXYNOS7570_POWER_BASE + 0x500)
#define EXYNOS7570_POWER_RST_STAT							(EXYNOS7570_POWER_BASE + 0x0404)
#define EXYNOS7570_POWER_MIPI_PHY_M4S2_CONTROL						(EXYNOS7570_POWER_BASE + 0x070C)
#define EXYNOS7570_POWER_INFORM0							(EXYNOS7570_POWER_BASE + 0x0800)
#define EXYNOS7570_POWER_INFORM1							(EXYNOS7570_POWER_BASE + 0x0804)
#define EXYNOS7570_POWER_INFORM3							(EXYNOS7570_POWER_BASE + 0x080C)
#define EXYNOS7570_POWER_INFORM4							(EXYNOS7570_POWER_BASE + 0x0840)
#define EXYNOS7570_POWER_PMUDBG								(EXYNOS7570_POWER_BASE + 0x0F00)
#define EXYNOS7570_POWER_PS_HOLD_CONTROL						(EXYNOS7570_POWER_BASE + 0x330C)
#define EXYNOS7570_POWER_UART_IO_SHARE_CTRL 						(EXYNOS7570_POWER_BASE + 0x6200)
#define EXYNOS7570_MMC_BASE	 							0x13540000
#define EXYNOS7570_MMC0_BASE								0x13540000
#define EXYNOS7570_GPIO_FSYS_BASE 							0x13750000
#define EXYNOS7570_GPR0CON 								(EXYNOS7570_GPIO_FSYS_BASE)
#define EXYNOS7570_GPR1CON 								(EXYNOS7570_GPIO_FSYS_BASE + 0x0020)
#define EXYNOS7570_GPR4CON 								(EXYNOS7570_GPIO_FSYS_BASE + 0x0040)
#define EXYNOS7570_GPIO_TOP_BASE 							0x139B0000
#define EXYNOS7570_GPC0CON 								(EXYNOS7570_GPIO_TOP_BASE)
#define EXYNOS7570_GPD1CON 								(EXYNOS7570_GPIO_TOP_BASE + 0x0060)
#define EXYNOS7570_GPD1DAT 								(EXYNOS7570_GPIO_TOP_BASE + 0x0064)
#define EXYNOS7570_GPD1PUD 								(EXYNOS7570_GPIO_TOP_BASE + 0x0068)
#define EXYNOS7570_GPE0CON 								(EXYNOS7570_GPIO_TOP_BASE + 0x0080)
#define EXYNOS7570_GPF0CON								(EXYNOS7570_GPIO_TOP_BASE + 0x00A0)
#define EXYNOS7570_ESE_TOP_BASE							0x139E0000
#define EXYNOS7570_GPC7CON								EXYNOS7570_ESE_TOP_BASE
#define EXYNOS7570_GPIO_TOUCH_BASE 							0x139D0000
#define EXYNOS7570_GPD2CON 								(EXYNOS7570_GPIO_TOUCH_BASE + 0x0020)
#define EXYNOS7570_PWMTIMER_BASE 							0x13970000
#define EXYNOS7570_UART_BASE 								0x13800000
#define EXYNOS7570_GPIO_ALIVE_BASE 							0x139F0000
#define EXYNOS7570_GPA0CON 								(EXYNOS7570_GPIO_ALIVE_BASE + 0x0040)
#define EXYNOS7570_GPA1CON 								(EXYNOS7570_GPIO_ALIVE_BASE + 0x0060)
#define EXYNOS7570_CMU_DISPAUD_BASE 							0x148D0000
#define EXYNOS7570_AUD_PLL_CON0 							(EXYNOS7570_CMU_DISPAUD_BASE + 0x01C0)
#define EXYNOS7570_SYSREG_DISPAUD_BASE 						0x148F0000
#define EXYNOS7570_SYSREG_DISPAUD_MIPI_PHY_CON						(EXYNOS7570_SYSREG_DISPAUD_BASE + 0x100C)

/* unnecessary definition */
#define EXYNOS7570_SYSREG_BASE								0x0
#define EXYNOS7570_GPIO_PART1_BASE							0x0
#define EXYNOS7570_GPIO_PART2_BASE							0x0
#define EXYNOS7570_GPIO_PART3_BASE							0x0
#define EXYNOS7570_ADC_BASE								0x0
#define EXYNOS7570_CLOCK_BASE								0x0
#define EXYNOS7570_FIMD_BASE								0x0
#define EXYNOS7570_MIPI_DSIM_BASE							0x0
#define EXYNOS7570_GPIO_PART4_BASE							0x0
#define EXYNOS7570_MODEM_BASE								0x0
#define EXYNOS7570_USBPHY_BASE								0x0
#define EXYNOS7570_USB_HOST_EHCI_BASE							0x0
#define EXYNOS7570_USBOTG_BASE								0x0
#define EXYNOS7570_SROMC_BASE								0x0

#endif	/* __EXYNOS7570_H__ */
