/*
 * Copyright (C) 2016 Samsung Electronics Co. Ltd
 *
 * S2MPW01 based on SPEEDY
 */


#ifndef __PMIC_S2MPW01_H__
#define __PMIC_S2MPW01_H__

/*
 * speedy slave address
 */
#define S2MPW01_SPEEDY_COMM_ADDR	0x0
#define S2MPW01_SPEEDY_PM_ADDR		0x1
#define S2MPW01_SPEEDY_RTC_ADDR		0x2
#define S2MPW01_SPEEDY_CHG_ADDR		0x4
#define S2MPW01_SPEEDY_FG_ADDR		0x5

enum s2mpw01_speedy_common_block {
	S2MPW01_COMMON_PMIC_ID	= 0x000,
	S2MPW01_COMMON_INT	= 0x005,
	S2MPW01_COMMON_INTM,
	S2MPW01_COMMON_SPD_CTRL1,
	S2MPW01_COMMON_SPD_CTRL2,
	S2MPW01_COMMON_SPD_CTRL3,
};

enum s2mpw01_speedy_power_manager_block {
	S2MPW01_INT1		= 0x00,
	S2MPW01_INT2,
	S2MPW01_INT3,
	S2MPW01_INT1M,
	S2MPW01_INT2M,
	S2MPW01_INT3M,
	S2MPW01_STATUS1,
	S2MPW01_STATUS2,
	S2MPW01_PWRONSRC,
	S2MPW01_OFFSRC,
	S2MPW01_RSVD1,
	S2MPW01_RTC_BUF,
	S2MPW01_CTRL1,
	S2MPW01_RSVD2,
	S2MPW01_CTRL3,
	S2MPW01_RSVD3,
	S2MPW01_RSVD4,
	S2MPW01_TIME_CTRL1,
	S2MPW01_TIME_CTRL2,
	S2MPW01_BUCK1_CTRL,
	S2MPW01_BUCK1_OUT1,
	S2MPW01_BUCK1_OUT2,
	S2MPW01_BUCK1_OUT3,
	S2MPW01_RSVD7,
	S2MPW01_RSVD8,
	S2MPW01_BUCK3_CTRL,
	S2MPW01_BUCK3_OUT,
	S2MPW01_BUCK4_CTRL,
	S2MPW01_BUCK4_OUT,
	S2MPW01_BUCK_RAMP,
	S2MPW01_BST_CTRL,
	S2MPW01_LDO1_DVS,
	S2MPW01_LDO1_CTRL1,
	S2MPW01_LDO1_CTRL2,
	S2MPW01_LDO2_CTRL1,
	S2MPW01_LDO2_CTRL2,
	S2MPW01_LDO3_CTRL,
	S2MPW01_LDO4_CTRL,
	S2MPW01_LDO5_CTRL,
	S2MPW01_LDO6_CTRL,
	S2MPW01_LDO7_CTRL,
	S2MPW01_LDO8_CTRL,
	S2MPW01_LDO9_CTRL,
	S2MPW01_LDO10_CTRL,
	S2MPW01_LDO11_CTRL,
	S2MPW01_LDO12_CTRL,
	S2MPW01_LDO13_CTRL,
	S2MPW01_LDO14_CTRL,
	S2MPW01_LDO15_CTRL,
	S2MPW01_LDO16_CTRL,
	S2MPW01_LDO17_CTRL,
	S2MPW01_LDO18_CTRL,
	S2MPW01_LDO19_CTRL,
	S2MPW01_LDO20_CTRL,
	S2MPW01_LDO21_CTRL,
	S2MPW01_LDO22_CTRL,
	S2MPW01_LDO23_CTRL,
	S2MPW01_LDO_DSCH1,
	S2MPW01_LDO_DSCH2,
	S2MPW01_LDO_DSCH3,
	S2MPW01_EXT_CTRL = 0xFF,
};

enum s2mpw01_speedy_rtc_block {
	S2MPW01_RTC_CTRL	= 0x00,
	S2MPW01_RTC_WTSR,
	S2MPW01_RTC_UPDATE,
	S2MPW01_RTC_BIAS_UP,
	S2MPW01_RTC_SEC,
	S2MPW01_RTC_MIN,
	S2MPW01_RTC_HOUR,
	S2MPW01_RTC_WEEK,
	S2MPW01_RTC_DAY,
	S2MPW01_RTC_MON,
	S2MPW01_RTC_YEAR,
	S2MPW01_RTC_A0SEC,
	S2MPW01_RTC_A0MIN,
	S2MPW01_RTC_A0HOUR,
	S2MPW01_RTC_A0WEEK,
	S2MPW01_RTC_A0DAY,
	S2MPW01_RTC_A0MON,
	S2MPW01_RTC_A0YEAR,
	S2MPW01_RTC_A1SEC,
	S2MPW01_RTC_A1MIN,
	S2MPW01_RTC_A1HOUR,
	S2MPW01_RTC_A1WEEK,
	S2MPW01_RTC_A1DAY,
	S2MPW01_RTC_A1MON,
	S2MPW01_RTC_A1YEAR,
	S2MPW01_RTC_OSC_CTRL,
};

enum s2mpw01_pmic_ldo {
	PMIC_LDO1,
	PMIC_LDO2,
	PMIC_LDO3,
	PMIC_LDO4,
	PMIC_LDO5,
	PMIC_LDO6,
	PMIC_LDO7,
	PMIC_LDO8,
	PMIC_LDO9,
	PMIC_LDO10,
	PMIC_LDO11,
	PMIC_LDO12,
	PMIC_LDO13,
	PMIC_LDO14,
	PMIC_LDO15,
	PMIC_LDO16,
	PMIC_LDO17,
	PMIC_LDO18,
	PMIC_LDO19,
	PMIC_LDO20,
	PMIC_LDO21,
	PMIC_LDO22,
	PMIC_LDO23,
};

enum s2mpw01_rtc_op {
	RTC_OP_WRITE,
	RTC_OP_READ,
};

enum s2mpw01_chip_version {
	EVT_0 = 0x0,
	EVT_1,
	EVT_2,
	EVT_3,
};

#define PMIC_REG_WRITE	0
#define PMIC_REG_DELAY	0xFE
#define PMIC_REG_END	0xFF

#define S2MPW01_COMMON_PMIC_VERSION_MASK	0xF

/* MRSTB */
#define S2MPW01_MRSTB_DISABLE		0x0
#define S2MPW01_MRSTB_ENABLE		0x1

#define S2MPW01_MRSTB_TIMER_3SEC	0x0
#define S2MPW01_MRSTB_TIMER_4SEC	0x1
#define S2MPW01_MRSTB_TIMER_5SEC	0x2
#define S2MPW01_MRSTB_TIMER_6SEC	0x3
#define S2MPW01_MRSTB_TIMER_7SEC	0x4
#define S2MPW01_MRSTB_TIMER_8SEC	0x5
#define S2MPW01_MRSTB_TIMER_9SEC	0x6
#define S2MPW01_MRSTB_TIMER_10SEC	0x7

#define PMIC_REG_WRITE	0
#define PMIC_REG_DELAY	0xFE
#define PMIC_REG_END	0xFF

/* charger */
#define S2MPW01_CHG_REG_INT1		0x00
#define S2MPW01_CHG_REG_INT2		0x01
#define S2MPW01_CHG_REG_INT3		0x02
#define S2MPW01_CHG_REG_INT1M		0x03
#define S2MPW01_CHG_REG_INT2M		0x04
#define S2MPW01_CHG_REG_INT3M		0x05
#define S2MPW01_CHG_REG_STATUS1		0x06
#define S2MPW01_CHG_REG_STATUS2		0x07
#define S2MPW01_CHG_REG_STATUS3		0x08
#define S2MPW01_CHG_REG_CTRL1       0x09
#define S2MPW01_CHG_REG_CTRL2       0x0A
#define S2MPW01_CHG_REG_CTRL3       0x0B
#define S2MPW01_CHG_REG_CTRL4       0x0C
#define S2MPW01_CHG_REG_CTRL5       0x0D
#define S2MPW01_CHG_REG_CTRL6       0x0E
#define S2MPW01_CHG_REG_CTRL7       0x0F
#define S2MPW01_CHG_REG_CTRL8       0x10
#define S2MPW01_CHG_REG_CTRL9		0x11

#define BIT(nr)	 (1UL << (nr))

/* S2MPW01_CHG_STATUS1 */
#define CHGVIN_STATUS_SHIFT	7
#define CHGVIN_STATUS_MASK	BIT(CHGVIN_STATUS_SHIFT)

#define CHGSTS_STATUS_SHIFT	4
#define CHGSTS_STATUS_MASK	BIT(CHGSTS_STATUS_SHIFT)

#define PRECHG_STATUS_SHIFT	3
#define PRECHG_STATUS_MASK	BIT(PRECHG_STATUS_SHIFT)

#define RE_CHG_STATUS_SHIFT	0
#define RE_CHG_STATUS_MASK	BIT(RE_CHG_STATUS_SHIFT)
#define CHG_DONE_STATUS_SHIFT	1
#define CHG_DONE_STATUS_MASK	BIT(CHG_DONE_STATUS_SHIFT)
#define TOPOFF_STATUS_SHIFT	2
#define TOPOFF_STATUS_MASK	BIT(TOPOFF_STATUS_SHIFT)

#define	PRECHG_STATUS_SHIFT	3
#define PRECHG_STATUS_MASK	BIT(PRECHG_STATUS_SHIFT)
#define CHGSTS_STATUS_SHIFT	4
#define CHGSTS_STATUS_MASK	BIT(CHGSTS_STATUS_SHIFT)
#define CIN2BAT_STATUS_SHIFT	5
#define CIN2BAT_STATUS_MASK	BIT(CIN2BAT_STATUS_SHIFT)
#define CHGVINOVP_STATUS_SHIFT 6
#define CHGVINOVP_STATUS_MASK	BIT(CHGVINOVP_STATUS_SHIFT)
#define CHGVIN_STATUS_SHIFT	7
#define CHGVIN_STATUS_MASK	BIT(CHGVIN_STATUS_SHIFT)

/* S2MPW01_CHG_STATUS2 */
#define UART_BOOT_OFF_STATUS_SHIFT	0
#define UART_BOOT_OFF_STATUS_MASK	BIT(UART_BOOT_OFF_STATUS_SHIFT)
#define USB_BOOT_ON_STATUS_SHIFT	1
#define USB_BOOT_ON_STATUS_MASK	BIT(USB_BOOT_ON_STATUS_SHIFT)
#define USB_BOOT_OFF_STATUS_SHIFT	2
#define USB_BOOT_OFF_STATUS_MASK	BIT(USB_BOOT_OFF_STATUS_SHIFT)
#define JIGON_STATUS_SHIFT	3
#define JIGON_STATUS_MASK	BIT(JIGON_STATUS_SHIFT)
#define AD_PATH_STATUS_SHIFT	4
#define AD_PATH_STATUS_MASK	BIT(AD_PATH_STATUS_SHIFT)
#define FCHG_STATUS_SHIFT	5
#define FCHG_STATUS_MASK	BIT(FCHG_STATUS_SHIFT)
#define CHGIN_INPUT_STATUS_SHIFT	6
#define CHGIN_INPUT_STATUS_MASK	BIT(CHGIN_INPUT_STATUS_SHIFT)
#define DET_BAT_STATUS_SHIFT	7
#define DET_BAT_STATUS_MASK	BIT(DET_BAT_STATUS_SHIFT)

/* S2MPW01_CHG_STATUS3 */
#define CVOK_STATUS_SHIFT	0
#define CVOK_STATUS_MASK	BIT(CVOK_STATUS_SHIFT)
#define UART_CABLE_STATUS_SHIFT	1
#define UART_CABLE_STATUS_MASK	BIT(UART_CABLE_STATUS_SHIFT)
#define FACT_LEAKAGE_STATUS_SHIFT	2
#define FACT_LEAKAGE_STATUS_MASK	BIT(FACT_LEAKAGE_STATUS_SHIFT)
#define UART_BOOT_ON_STATUS_SHIFT	3
#define UART_BOOT_ON_STATUS_MASK	BIT(UART_BOOT_ON_STATUS_SHIFT)
#define TMROUT_STATUS_SHIFT	4
#define TMROUT_STATUS_MASK	BIT(TMROUT_STATUS_SHIFT)
#define CHGTSD_STATUS_SHIFT	5
#define CHGTSD_STATUS_MASK	BIT(CHGTSD_STATUS_SHIFT)
#define MRSTB_STATUS_SHIFT	6
#define MRSTB_STATUS_MASK	BIT(MRSTB_STATUS_SHIFT)
#define WDT_STATUS_SHIFT	7
#define WDT_STATUS_MASK	BIT(WDT_STATUS_SHIFT)

#define ACOK_STATUS_SHIFT	2
#define ACOK_STATUS_MASK	BIT(ACOK_STATUS_SHIFT)

#define S2MPW01_MUIC_ID		2

#define UNKNOWN_DEVICE		0
#define TA_DEVICE		1
#define USB_DEVICE		2
#define JIG_USB_ON		3
#define JIG_USB_OFF		4
#define JIG_UART_ON		5
#define JIG_UART_OFF	6

/* fuelgauge */
#define S2MPW01_FG_REG_STATUS  0x00
#define S2MPW01_FG_REG_IRQ  0x02
#define S2MPW01_FG_REG_INTM  0x03
#define S2MPW01_FG_REG_RVBAT  0x04
#define S2MPW01_FG_REG_ROCV  0x06
#define S2MPW01_FG_REG_RSOC  0x08
#define S2MPW01_FG_REG_RTEMP  0x0A
#define S2MPW01_FG_REG_RBATCAP  0x0C
#define S2MPW01_FG_REG_RZADJ  0x0E
#define S2MPW01_FG_REG_RBATZ0  0x10
#define S2MPW01_FG_REG_RBATZ1  0x12
#define S2MPW01_FG_REG_IRQ_LVL  0x14
#define S2MPW01_FG_REG_START  0x16
#define S2MPW01_FG_REG_MONOUT_CFG  0x19
#define S2MPW01_FG_REG_CURR  0x1A

/* S2MPW01_INT1 register bit */
#define S2MPW01_INT1_MRB	(1 << 7)
#define S2MPW01_INT1_PWRON1S	(1 << 6)
#define S2MPW01_INT1_ACOKR	(1 << 5)
#define S2MPW01_INT1_ACOKF	(1 << 4)
#define S2MPW01_INT1_JIGONBR	(1 << 3)
#define S2MPW01_INT1_JIGONBF	(1 << 2)
#define S2MPW01_INT1_PWRONR	(1 << 1)
#define S2MPW01_INT1_PWRONF	(1 << 0)

/* S2MPW01_INT2 register bit */
#define S2MPW01_INT2_WRSTB	(1 << 7)	/* warm reset */
#define S2MPW01_INT2_WTSR	(1 << 5)	/* watchdog */

/* S2MPW01_INT3 register bit */
#define S2MPW01_INT3_TSD	(1 << 2)	/* thermal shutdown */

/* S2MPW01_STATUS1 register bit */
#define S2MPW01_STATUS1_PWRON1S	(1 << 5)
#define S2MPW01_STATUS1_ACOK	(1 << 2)
#define S2MPW01_STATUS1_JIGON	(1 << 1)
#define S2MPW01_STATUS1_PWRON	(1 << 0)

/* S2MPW01_STATUS2 register bit */
#define S2MPW01_STATUS2_WTSR	(1 << 5)

/* S2MPW01_PWRON register bit */
#define S2MPW01_PWRON_WTSR	(1 << 7)
#define S2MPW01_PWRON_ALARM1	(1 << 5)
#define S2MPW01_PWRON_ALARM0	(1 << 4)
#define S2MPW01_PWRON_MRST	(1 << 3)
#define S2MPW01_PWRON_ACOK	(1 << 2)
#define S2MPW01_PWRON_JIGONB	(1 << 1)
#define S2MPW01_PWRON_PWRON	(1 << 0)

/* S2MPW01_OFFSRC register bit */
#define S2MPW01_OFFSRC_PWRHOLD	(1 << 4)
#define S2MPW01_OFFSRC_LDO3OK	(1 << 3)
#define S2MPW01_OFFSRC_TIMEOUT	(1 << 2)
#define S2MPW01_OFFSRC_TSD	(1 << 1)

/* Hidden register */
#define S2MPW01_MON_POINTER	(0x1A)
#define S2MPW01_MON_DADDRESS	(0x1B)
#define S2MPW01_MON_DDATA	(0x1C)

#define S2MPW01_LDO1_2_OFFSET   (0x4)
#define S2MPW01_LDO3_8_10_13_15_17_21_OFFSET    (0x1C)
#define S2MPW01_BUCK1_2_OFFSET  (0x20)
#define S2MPW01_BUCK3_OFFSET    (0x30)
#define S2MPW01_BUCK4_OFFSET    (0x60)

#define S2MPW01_EXT_CTRL_BST    (1 << 5)
#define S2MPW01_EXT_CTRL_L12L13 (1 << 4)
#define S2MPW01_EXT_CTRL_L8     (1 << 2)
#define S2MPW01_EXT_CTRL_L9     (1 << 1)
#define S2MPW01_EXT_CTRL_L19    (1 << 0)

struct pmic_reg {
	u8 addr;
	u8 data;
	u8 mask;
};

#define PMIC_COMMON_WRITE(A, B)		speedy_write(S2MPW01_SPEEDY_COMM_ADDR, A, B)
#define PMIC_COMMON_READ(A, B)		speedy_read(S2MPW01_SPEEDY_COMM_ADDR, A, B)

#define PMIC_WRITE(A, B)			speedy_write(S2MPW01_SPEEDY_PM_ADDR, A, B)
#define PMIC_READ(A, B)			speedy_read(S2MPW01_SPEEDY_PM_ADDR, A, B)
#define PMIC_MULTI_READ(A, B)		speedy_multi_read(S2MPW01_SPEEDY_PM_ADDR, A, B)

#define S2MPW01_RTC_WRITE(A, B)		speedy_write(S2MPW01_SPEEDY_RTC_ADDR, A, B)
#define S2MPW01_RTC_READ(A, B)		speedy_read(S2MPW01_SPEEDY_RTC_ADDR, A, B)
#define S2MPW01_RTC_MULTI_READ(A, B)	speedy_multi_read(S2MPW01_SPEEDY_RTC_ADDR, A, B)

#define PMIC_CHARGER_WRITE(A, B)			speedy_write(S2MPW01_SPEEDY_CHG_ADDR, A, B)
#define PMIC_CHARGER_READ(A, B)			speedy_read(S2MPW01_SPEEDY_CHG_ADDR, A, B)

#define PMIC_FUELGAUGE_WRITE(A, B)			speedy_write(S2MPW01_SPEEDY_FG_ADDR, A, B)
#define PMIC_FUELGAUGE_READ(A, B)			speedy_read(S2MPW01_SPEEDY_FG_ADDR, A, B)

int pmic_check_jigon_status(void);
int pmic_check_pwrkey_pwron(void);
int pmic_check_jigon_pwron(void);
void pmic_set_ext_ctrl(u8 val);
u8 pmic_get_pmic_chip_version(void);
void pmic_wtsr_enable(void);
void pmic_wtsr_disable(void);

#endif	/* __PMIC_S2MPW01_H__ */

