/*
 * (C) Copyright 2015 Samsung Electronics
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 *
 */

#ifndef __LDFW_H_
#define __LDFW_H_

#include <common.h>
#include <asm/types.h>
#include <asm/arch/movi_partition.h>

#define EXYNOS7570_LDFW_NWD_ADDR	(CONFIG_SYS_SDRAM_BASE + 0x2000000)
#define EXYNOS7570_LDFW_PARTITION_SIZE	(PART_SIZE_LOADABLE_FW)
#define EXYNOS_LDFW_MAGIC		(0x10adab1e)

#define LDFW_DEBUG

#define CHECK_SIGNATURE_FAIL		(0x2)
#define CHECK_ROLL_BACK_COUNT_FAIL	(0x20)

#ifdef LDFW_DEBUG
#define LDFW_INFO(format, arg...)	printf(format, ##arg)
#define LDFW_WARN(format, arg...)	printf(format, ##arg)
#define LDFW_ERR(format, arg...)	printf(format, ##arg)
#else
#define LDFW_INFO(msg)
#define LDFW_WARN(msg)
#define LDFW_ERR(format, arg...)	printf(format, ##arg)
#endif

#ifndef __ASSEMBLY__
int init_ldfws(void);
#endif	/* __ASSEMBLY__ */

#endif	/* __LDFW_H_ */
