/*
 * Copyright (C) 2016 Samsung Electronics
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <version.h>

.macro	push, xreg1, xreg2
stp	\xreg1, \xreg2, [sp, #-16]!
.endm

.macro	pop, xreg1, xreg2
ldp	\xreg1, \xreg2, [sp], #16
.endm

	.globl lowlevel_init
lowlevel_init:
	ldr	x0, =(CONFIG_SYS_INIT_SP_ADDR)
	bic	sp, x0, #0xf    /* 16-byte alignment for ABI compliance */
	push	x30, x29

	bl	read_om

#if defined(CONFIG_MACH_ESPRESSO7270_SIP)
	bl	display_gpio_init
	bl	sub_main_int2_init
#endif
	pop	x30, x29
	ret

#if defined(CONFIG_MACH_ESPRESSO7270_SIP)
display_gpio_init:
	/* Set XV_TES(GPE0_2) to DISP_TES */
	ldr	x0, =EXYNOS7570_GPE0CON
	ldr	w1, [x0]
	bic	w1, w1, #(0xF << 8)
	orr	w1, w1, #(0x2 << 8)
	str	w1, [x0]
	ret

sub_main_int2_init:
	/* Change SUB_MAIN_INT2(GPA1_3) to input */
	ldr	x0, =EXYNOS7570_GPA1CON
	ldr	w1, [x0]
	bic	w1, w1, #(0x2 << 12)
	str	w1, [x0]
	ret
#endif

.global pmic_gpio_init
pmic_gpio_init:
	/* Set PMIC WRSTBI(GPD1_6) to Pull-up/down disable */
	ldr	x0, =EXYNOS7570_GPD1PUD
	ldr	w1, [x0]
	bic	w1, w1, #(0x3 << 12)
	str	w1, [x0]

	/* Set PMIC WRSTBI(GPD1_6) to Output */
	ldr	x0, =EXYNOS7570_GPD1CON
	ldr	w1, [x0]
	bic	w1, w1, #(0xF << 24)
	orr	w1, w1, #(0x1 << 24)
	str	w1, [x0]

	/* Set PMIC WRSTBI(GPD1_6) to High */
	ldr	x0, =EXYNOS7570_GPD1DAT
	ldr	w1, [x0]
	orr	w1, w1, #(0x1 << 6)
	str	w1, [x0]
	ret
