/* drivers/video/exynos/7570/decon_config.h
 *
 * decon configuration file for Samsung DECON driver.
 *
 * Copyright@ Samsung Electronics Co. LTD
 *
 * Manseok Kim <manseoks.kim@samsung.com> *
 * Yeongran Shin <yr613.shin@samsung.com> *
 *
 * This software is proprietary of Samsung Electronics.
 * No part of this software, either material or conceptual may be copied or distributed, transmitted,
 * transcribed, stored in a retrieval system or translated into any human or computer language in any form by any means,
 * electronic, mechanical, manual or otherwise, or disclosed
 * to third parties without the express written permission of Samsung Electronics.


 * Alternatively, this program is free software in case of open source projec;
 * you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.

*/

#ifndef ___SAMSUNG_DECON_CONFIG_H__
#define ___SAMSUNG_DECON_CONFIG_H__


#ifdef CONFIG_CPU_EXYNOS7570 /* EXYNOS7570 */
/* SFR Base Address */
#define DECON_INT_BASE_ADDR	0x14830000
#define DSIM_1ST_BASE_ADDR	0x14800000
#define DECON_SMMU_BASE_ADDR	0x14860000

/* Dummy Addresses to fix Build errors */
#define DECON_EXT_BASE_ADDR	0x00000000
#define DSIM_2ND_BASE_ADDR	0x00000000

#define DECON_IP_VER		IP_VER_DECON_7I
#define DECON_MAX_WIN		3
#endif /* CONFIG_CPU_EXYNOS7570 */

/*
 ***** Board Dependency *****
*/
/* Display Properties */
#define BD_PSR_MODE	DECON_MIPI_COMMAND_MODE
#define BD_TRIG_MODE	DECON_HW_TRIG
#define BD_DSI_MODE	DSI_MODE_SINGLE

/*
 ***** COMMON *****
*/

/* Display Properties */
static struct exynos_decon_platdata exynos_decon_pdata = {
	.ip_ver 	= DECON_IP_VER,
	.psr_mode 	= BD_PSR_MODE,
	.trig_mode 	= BD_TRIG_MODE,
	.dsi_mode 	= BD_DSI_MODE,
	.max_win 	= DECON_MAX_WIN,
	.default_win 	= 0,
};

/* GET platdata API list */
static inline struct exynos_decon_platdata *get_decon_pdata(void)
{
	return &exynos_decon_pdata;
}

#endif /* SAMSUNG_DECON_CONFIG_H */
