/* drivers/video/exynos/panels/ea8064g_mipi_lcd.c
 *
 * Samsung SoC MIPI LCD driver.
 *
 * Copyright (c) 2015 Samsung Electronics
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
*/

#include "../dsim.h"
#include "lcd_ctrl.h"
#include "decon_lcd.h"

#define MAX_BRIGHTNESS 255
#define MIN_BRIGHTNESS 0
#define DEFAULT_BRIGHTNESS 0

static int ea8064g_get_brightness(struct backlight_device *bd)
{
	return 50;
}

static int ea8064g_set_brightness(struct backlight_device *bd)
{
	return 1;
}

static int ea8064g_probe(struct dsim_device *dsim)
{
	return 1;
}

static int ea8064g_displayon(struct dsim_device *dsim)
{
	lcd_init(dsim->id, dsim->lcd_info);
	lcd_enable_exynos(dsim->id);
	return 1;
}

static int ea8064g_suspend(struct dsim_device *dsim)
{
	return 1;
}

static int ea8064g_resume(struct dsim_device *dsim)
{
	return 1;
}

struct mipidsim_lcd_driver ea8064g_mipi_lcd_driver = {
	.probe		= ea8064g_probe,
	.displayon	= ea8064g_displayon,
	.suspend	= ea8064g_suspend,
	.resume		= ea8064g_resume,
};

struct mipidsim_lcd_driver *decon_get_panel_info(void)
{
	return &ea8064g_mipi_lcd_driver;
}
