/* drivers/video/exynos/panels/s6e8aa0_param.h
 *
 * Samsung SoC MIPI LCD PARAMETERS
 *
 * Copyright@ Samsung Electronics Co. LTD
 *
 * Manseok Kim, <mansoeks.kim@samsung.com> *
 *
 * This software is proprietary of Samsung Electronics.
 * No part of this software, either material or conceptual may be copied or distributed, transmitted,
 * transcribed, stored in a retrieval system or translated into any human or computer language in any form by any means,
 * electronic, mechanical, manual or otherwise, or disclosed
 * to third parties without the express written permission of Samsung Electronics.


 * Alternatively, this program is free software in case of open source projec;
 * you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.

*/

#ifndef __S6E8AA0_PARAM_H__
#define __S6E8AA0_PARAM_H__

static const unsigned char apply_level_1_key[3] = {
	/* command */
	0xF0,
	/* parameter */
	0x5A, 0x5A
};
static const unsigned char apply_level_2_key[3] = {
	/* command */
	0xf1,
	/* parameter */
	0x5a, 0x5a
};

static const unsigned char sleep_out[1] = {
	0x11,
};

static const unsigned char panel_condition_set[39] = {
	0xF8,
	0x3D, 0x35, 0x00, 0x00, 0x00, 0x93, 0x00, 0x3C, 0x7D, 0x08,
	0x27, 0x7D, 0x3F, 0x00, 0x00, 0x00, 0x20, 0x04, 0x08, 0x6E,
	0x00, 0x00, 0x00, 0x02, 0x08, 0x08, 0x23, 0x23, 0xC0, 0xC8,
	0x08, 0x48, 0xC1, 0x00, 0xC1, 0xFF, 0xFF, 0xC8
};

static const unsigned char panel_condition_update[4] = {
	0xF2, 0x80, 0x03, 0x0D
};

static const unsigned char gamma_condition_set[26] = {
	0xFA,
	0x01, 0x46, 0x46, 0x46, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80,
	0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x00,
	0xBE, 0x00, 0xBE, 0x00, 0xBE
};

static const unsigned char gamma_update[2] = {
	0xF7,0x03
};

static const unsigned char etc_set_source_ctrl[3] = {
	0xF6,0x00, 0x02
};

static const unsigned char etc_set_pentile_ctrl[10] = {
	0xB6,
	0x0C, 0x02, 0x03, 0x32, 0xFF, 0x44, 0x44, 0xC0, 0x00
};

static const unsigned char elvss_NVM_set[15] = {
	0xD9,
	0x14, 0x40, 0x0C, 0xCB, 0xCE, 0x6E, 0xC4, 0x07, 0x40, 0x41,
	0xCB, 0x00, 0x60, 0x19
};

static const unsigned char etc_set_power_ctrl[8] = {
	0xF4,
	0xCF, 0x0A, 0x12, 0x10, 0x1E, 0x33, 0x02
};

static const unsigned char elvss_ctrl_set[3] = {
	0xB1, 0x04, 0x95
};

static const unsigned char acl_ctrl1[2] = {
	0xC0, 0x01
};

static const unsigned char acl_ctrl2[28] = {
	0x47, 0x53, 0x13, 0x53, 0x00,
	0x00, 0x02, 0xCF, 0x00, 0x00,
	0x04, 0xFF, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x01, 0x09, 0x10,
	0x18, 0x1F, 0x27, 0x2E, 0x36,
	0x3D, 0x45, 0x4C
};

#endif /* __S6E8AA0_PARAM_H__ */

